unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XmlIni, ComCtrls;

type
  TForm1 = class(TForm)
    edSection: TEdit;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    Label1: TLabel;
    ListBox2: TListBox;
    Label2: TLabel;
    Label3: TLabel;
    edKey: TEdit;
    Label4: TLabel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Label5: TLabel;
    Button11: TButton;
    Button12: TButton;
    OpenDialog2: TOpenDialog;
    SaveDialog2: TSaveDialog;
    mmValue: TRichEdit;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure edSectionChange(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure edKeyChange(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
  private
  public
    FEditXmlIni: TXmlIni;
    procedure ReloadSections;
    procedure ReloadKeys;
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    FEditXmlIni.LoadFromFile(OpenDialog1.FileName);
    CheckBox1.Checked := FEditXmlIni.Compressed;
    CheckBox2.Checked := FEditXmlIni.AutoSave;
    CheckBox3.Checked := FEditXmlIni.IgnoreCase;
    ReloadSections;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
    FEditXmlIni.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.ReloadSections;
var
  i: Integer;
begin
  FEditXmlIni.Collation;
  ListBox1.Items.Clear;
  for i := 0 to FEditXmlIni.Count-1 do
    ListBox1.Items.Add(FEditXmlIni.SectionByIndex[i].Name);
end;

procedure TForm1.ReloadKeys;
var
  i: Integer;
begin
  FEditXmlIni[edSection.Text].Collation;
  ListBox2.Items.Clear;
  for i := 0 to FEditXmlIni[edSection.Text].Count-1 do
    ListBox2.Items.Add(FEditXmlIni[edSection.Text].KeyByIndex[i].Name);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FEditXmlIni := TXmlIni.Create;
  
  CheckBox1.Checked := FEditXmlIni.Compressed;
  CheckBox2.Checked := FEditXmlIni.AutoSave;
  CheckBox3.Checked := FEditXmlIni.IgnoreCase;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FEditXmlIni.Free;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex >= 0 then
    edSection.Text := ListBox1.Items[ListBox1.ItemIndex];
  edKey.Text := '';
  mmValue.Text := '';
end;

procedure TForm1.edSectionChange(Sender: TObject);
begin
  ReloadKeys;
end;

procedure TForm1.ListBox2Click(Sender: TObject);
begin
  if ListBox2.ItemIndex >= 0 then
    edKey.Text := ListBox2.Items[ListBox2.ItemIndex];
end;

procedure TForm1.edKeyChange(Sender: TObject);
begin
  Button4Click(nil);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  mmValue.Lines.Text := FEditXmlIni[edSection.Text][edKey.Text];
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  FEditXmlIni[edSection.Text][edKey.Text] := mmValue.Lines.Text;
  ReloadSections;
  ReloadKeys;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  FEditXmlIni.Compressed := CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  FEditXmlIni.AutoSave := CheckBox2.Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  FEditXmlIni.IgnoreCase := CheckBox3.Checked;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Form2.mmValue.Lines.Text := FEditXmlIni.SaveToString;
  Form2.ShowModal;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Form2.ShowModal;
  FEditXmlIni.LoadFromString(Form2.mmValue.Lines.Text);
  CheckBox1.Checked := FEditXmlIni.Compressed;
  ReloadSections;
  ReloadKeys;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  FEditXmlIni.Clear;
  ReloadSections;
  ReloadKeys;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  Form2.ShowModal;
  FEditXmlIni.LoadFromBase64String(Form2.mmValue.Lines.Text);
  CheckBox1.Checked := FEditXmlIni.Compressed;
  ReloadSections;
  ReloadKeys;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  Form2.mmValue.Lines.Text := FEditXmlIni.SaveToBase64String;
  Form2.ShowModal;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  if (edSection.Text <> '') and (edKey.Text <> '') then
    if SaveDialog2.Execute then
      FEditXmlIni[edSection.Text].Key[edKey.Text].AsStream.SaveToFile(SaveDialog2.FileName);
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  if (edSection.Text <> '') and (edKey.Text <> '') then
    if OpenDialog2.Execute then
    begin
      FEditXmlIni[edSection.Text].Key[edKey.Text].AsStream.LoadFromFile(OpenDialog2.FileName);
      mmValue.Lines.Text := FEditXmlIni[edSection.Text].Key[edKey.Text].Text;
    end;
end;

end.
